"""A web3.py Contract class for the IInitializableAToken contract.

DO NOT EDIT.  This file was generated by pypechain v0.0.43.
See documentation at https://github.com/delvtech/pypechain """

# contracts have PascalCase names
# pylint: disable=invalid-name

# contracts control how many attributes and arguments we have in generated code
# pylint: disable=too-many-instance-attributes
# pylint: disable=too-many-arguments

# we don't need else statement if the other conditionals all have return,
# but it's easier to generate
# pylint: disable=no-else-return

# This file is bound to get very long depending on contract sizes.
# pylint: disable=too-many-lines

# methods are overriden with specific arguments instead of generic *args, **kwargs
# pylint: disable=arguments-differ

# consumers have too many opinions on line length
# pylint: disable=line-too-long


from __future__ import annotations

from typing import Any, Iterable, Sequence, Type, cast

from eth_account.signers.local import LocalAccount
from eth_typing import ABI, ChecksumAddress, HexStr
from hexbytes import HexBytes
from pypechain.core import combomethod_typed, dataclass_to_tuple
from typing_extensions import Self
from web3 import Web3
from web3._utils.events import EventLogErrorFlags
from web3._utils.filters import LogFilter
from web3.contract.contract import (
    Contract,
    ContractConstructor,
    ContractEvent,
    ContractEvents,
    ContractFunction,
    ContractFunctions,
)
from web3.logs import WARN
from web3.types import BlockIdentifier, StateOverride, TxParams, TxReceipt

from .IInitializableATokenTypes import InitializedEvent

structs = {}


class IInitializableATokenInitializeContractFunction(ContractFunction):
    """ContractFunction for the initialize method."""

    def __call__(self, pool: str, treasury: str, underlyingAsset: str, incentivesController: str, aTokenDecimals: int, aTokenName: str, aTokenSymbol: str, params: bytes) -> IInitializableATokenInitializeContractFunction:  # type: ignore
        clone = super().__call__(
            dataclass_to_tuple(pool),
            dataclass_to_tuple(treasury),
            dataclass_to_tuple(underlyingAsset),
            dataclass_to_tuple(incentivesController),
            dataclass_to_tuple(aTokenDecimals),
            dataclass_to_tuple(aTokenName),
            dataclass_to_tuple(aTokenSymbol),
            dataclass_to_tuple(params),
        )
        self.kwargs = clone.kwargs
        self.args = clone.args
        return self

    def call(
        self,
        transaction: TxParams | None = None,
        block_identifier: BlockIdentifier = "latest",
        state_override: StateOverride | None = None,
        ccip_read_enabled: bool | None = None,
    ) -> None:
        """returns None."""
        # Define the expected return types from the smart contract call

        # Call the function


class IInitializableATokenContractFunctions(ContractFunctions):
    """ContractFunctions for the IInitializableAToken contract."""

    initialize: IInitializableATokenInitializeContractFunction

    def __init__(
        self,
        abi: ABI,
        w3: "Web3",
        address: ChecksumAddress | None = None,
        decode_tuples: bool | None = False,
    ) -> None:
        super().__init__(abi, w3, address, decode_tuples)
        self.initialize = (
            IInitializableATokenInitializeContractFunction.factory(
                "initialize",
                w3=w3,
                contract_abi=abi,
                address=address,
                decode_tuples=decode_tuples,
                abi_element_identifier="initialize",
            )
        )


class IInitializableATokenInitializedContractEvent(ContractEvent):
    """ContractEvent for Initialized."""

    # super() get_logs and create_filter methods are generic, while our version adds values & types
    # pylint: disable=arguments-differ

    # pylint: disable=useless-parent-delegation
    def __init__(self, *argument_names: tuple[str]) -> None:
        super().__init__(*argument_names)

    @combomethod_typed
    def get_logs_typed(
        self,
        argument_filters: dict[str, Any] | None = None,
        from_block: BlockIdentifier | None = None,
        to_block: BlockIdentifier | None = None,
        block_hash: HexBytes | None = None,
    ) -> Iterable[InitializedEvent]:
        """Extension of `get_logs` that return a typed dataclass of the event."""
        abi_events = super().get_logs(
            argument_filters=argument_filters,
            from_block=from_block,
            to_block=to_block,
            block_hash=block_hash,
        )
        # TODO there may be issues with this function if the user uses a middleware that changes event structure.
        return [
            InitializedEvent(
                log_index=abi_event.logIndex,
                transaction_index=abi_event.transactionIndex,
                transaction_hash=abi_event.transactionHash,
                address=abi_event.address,
                block_hash=abi_event.blockHash,
                block_number=abi_event.blockNumber,
                args=InitializedEvent.InitializedEventArgs(
                    underlyingAsset=abi_event.args["underlyingAsset"],
                    pool=abi_event.args["pool"],
                    treasury=abi_event.args["treasury"],
                    incentivesController=abi_event.args["incentivesController"],
                    aTokenDecimals=abi_event.args["aTokenDecimals"],
                    aTokenName=abi_event.args["aTokenName"],
                    aTokenSymbol=abi_event.args["aTokenSymbol"],
                    params=abi_event.args["params"],
                ),
            )
            for abi_event in abi_events
        ]

    @combomethod_typed
    def process_receipt_typed(
        self, txn_receipt: TxReceipt, errors: EventLogErrorFlags = WARN
    ) -> Iterable[InitializedEvent]:
        """Extension of `process_receipt` that return a typed dataclass of the event."""
        abi_events = super().process_receipt(txn_receipt, errors)
        # TODO there may be issues with this function if the user uses a middleware that changes event structure.
        return [
            InitializedEvent(
                log_index=abi_event.logIndex,
                transaction_index=abi_event.transactionIndex,
                transaction_hash=abi_event.transactionHash,
                address=abi_event.address,
                block_hash=abi_event.blockHash,
                block_number=abi_event.blockNumber,
                args=InitializedEvent.InitializedEventArgs(
                    underlyingAsset=abi_event.args["underlyingAsset"],
                    pool=abi_event.args["pool"],
                    treasury=abi_event.args["treasury"],
                    incentivesController=abi_event.args["incentivesController"],
                    aTokenDecimals=abi_event.args["aTokenDecimals"],
                    aTokenName=abi_event.args["aTokenName"],
                    aTokenSymbol=abi_event.args["aTokenSymbol"],
                    params=abi_event.args["params"],
                ),
            )
            for abi_event in abi_events
        ]

    @combomethod_typed
    def create_filter(  # type: ignore
        self,
        *,  # PEP 3102
        argument_filters: dict[str, Any] | None = None,
        from_block: BlockIdentifier | None = None,
        to_block: BlockIdentifier = "latest",
        address: ChecksumAddress | None = None,
        topics: Sequence[Any] | None = None,
    ) -> LogFilter:
        return cast(
            LogFilter,
            super().create_filter(
                argument_filters=argument_filters,
                from_block=from_block,
                to_block=to_block,
                address=address,
                topics=topics,
            ),
        )


class IInitializableATokenContractEvents(ContractEvents):
    """ContractEvents for the IInitializableAToken contract."""

    Initialized: Type[IInitializableATokenInitializedContractEvent]

    def __init__(
        self,
        abi: ABI,
        w3: "Web3",
        address: ChecksumAddress | None = None,
    ) -> None:
        super().__init__(abi, w3, address)
        self.Initialized = cast(
            Type[IInitializableATokenInitializedContractEvent],
            IInitializableATokenInitializedContractEvent.factory(
                "Initialized",
                w3=w3,
                contract_abi=abi,
                address=address,
                event_name="Initialized",
            ),
        )


iinitializableatoken_abi: ABI = cast(
    ABI,
    [
        {
            "type": "function",
            "name": "initialize",
            "inputs": [
                {
                    "name": "pool",
                    "type": "address",
                    "internalType": "contract IPool",
                },
                {
                    "name": "treasury",
                    "type": "address",
                    "internalType": "address",
                },
                {
                    "name": "underlyingAsset",
                    "type": "address",
                    "internalType": "address",
                },
                {
                    "name": "incentivesController",
                    "type": "address",
                    "internalType": "contract IAaveIncentivesController",
                },
                {
                    "name": "aTokenDecimals",
                    "type": "uint8",
                    "internalType": "uint8",
                },
                {
                    "name": "aTokenName",
                    "type": "string",
                    "internalType": "string",
                },
                {
                    "name": "aTokenSymbol",
                    "type": "string",
                    "internalType": "string",
                },
                {"name": "params", "type": "bytes", "internalType": "bytes"},
            ],
            "outputs": [],
            "stateMutability": "nonpayable",
        },
        {
            "type": "event",
            "name": "Initialized",
            "inputs": [
                {
                    "name": "underlyingAsset",
                    "type": "address",
                    "indexed": True,
                    "internalType": "address",
                },
                {
                    "name": "pool",
                    "type": "address",
                    "indexed": True,
                    "internalType": "address",
                },
                {
                    "name": "treasury",
                    "type": "address",
                    "indexed": False,
                    "internalType": "address",
                },
                {
                    "name": "incentivesController",
                    "type": "address",
                    "indexed": False,
                    "internalType": "address",
                },
                {
                    "name": "aTokenDecimals",
                    "type": "uint8",
                    "indexed": False,
                    "internalType": "uint8",
                },
                {
                    "name": "aTokenName",
                    "type": "string",
                    "indexed": False,
                    "internalType": "string",
                },
                {
                    "name": "aTokenSymbol",
                    "type": "string",
                    "indexed": False,
                    "internalType": "string",
                },
                {
                    "name": "params",
                    "type": "bytes",
                    "indexed": False,
                    "internalType": "bytes",
                },
            ],
            "anonymous": False,
        },
    ],
)


class IInitializableATokenContract(Contract):
    """A web3.py Contract class for the IInitializableAToken contract."""

    abi: ABI = iinitializableatoken_abi
    # We change `bytecode` as needed for linking, but keep
    # `_raw_bytecode` unchanged as an original copy.
    # pylint: disable=line-too-long
    _raw_bytecode: HexStr | None = HexStr("0x")

    def __init__(self, address: ChecksumAddress | None = None) -> None:
        # Initialize parent Contract class
        super().__init__(address=address)
        self.functions = IInitializableATokenContractFunctions(iinitializableatoken_abi, self.w3, address)  # type: ignore
        self.events = IInitializableATokenContractEvents(iinitializableatoken_abi, self.w3, address)  # type: ignore

    events: IInitializableATokenContractEvents

    functions: IInitializableATokenContractFunctions

    @classmethod
    def constructor(cls) -> ContractConstructor:  # type: ignore
        """Creates a transaction with the contract's constructor function.

        Parameters
        ----------

        w3 : Web3
            A web3 instance.
        account : LocalAccount
            The account to use to deploy the contract.

        Returns
        -------
        Self
            A deployed instance of the contract.

        """
        cls.bytecode = cls._raw_bytecode
        if cls.bytecode is not None:

            # bytecode needs to be in hex for web3
            cls.bytecode = HexBytes(cls.bytecode)

        return super().constructor()

    @classmethod
    def deploy(cls, w3: Web3, account: LocalAccount | ChecksumAddress) -> Self:
        """Deploys an instance of the contract.

        Parameters
        ----------
        w3 : Web3
            A web3 instance.
        account : LocalAccount
            The account to use to deploy the contract.

        Returns
        -------
        Self
            A deployed instance of the contract.
        """
        deployer = cls.factory(w3=w3)
        constructor_fn = deployer.constructor()

        # if an address is supplied, try to use a web3 default account
        if isinstance(account, str):
            tx_hash = constructor_fn.transact({"from": account})
            tx_receipt = w3.eth.wait_for_transaction_receipt(tx_hash)

            deployed_contract = deployer(address=tx_receipt.contractAddress)  # type: ignore
            return deployed_contract

        # otherwise use the account provided.
        deployment_tx = constructor_fn.build_transaction()
        current_nonce = w3.eth.get_transaction_count(account.address, "pending")
        deployment_tx.update({"nonce": current_nonce})

        # Sign the transaction with local account private key
        signed_tx = account.sign_transaction(deployment_tx)

        # Send the signed transaction and wait for receipt
        tx_hash = w3.eth.send_raw_transaction(signed_tx.raw_transaction)
        tx_receipt = w3.eth.wait_for_transaction_receipt(tx_hash)

        deployed_contract = deployer(address=tx_receipt.contractAddress)  # type: ignore
        return deployed_contract

    @classmethod
    def factory(
        cls, w3: Web3, class_name: str | None = None, **kwargs: Any
    ) -> Type[Self]:
        """Initializes the contract object.

        Parameters
        ----------
        w3 : Web3
            A web3 instance.
        class_name: str | None
            The instance class name.

        Returns
        -------
        Self
            An instance of the contract class.
        """
        contract = super().factory(w3, class_name, **kwargs)
        contract.functions = IInitializableATokenContractFunctions(
            iinitializableatoken_abi, w3, None
        )

        return contract
